﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ThrowInExpressionInProperties {

	class Person {
		private string name;
		
		public Person(string name) => this.name = name ?? throw new ArgumentNullException(nameof(name));

		public string Name {
			get => name;
			set => name = value ?? throw new ArgumentNullException();
		}
	}

	class Program {

		static void PrintPersonName(Person p) {
			if (p == null) throw new ArgumentNullException(nameof(p));

			Console.WriteLine($"Name: {p.Name}");
		}

		static void Main(string[] args) {
			var p = new Person("Pavel");

			// p.Name = null;
			PrintPersonName(p);
		}
	}
}
